

; ImageView v1.0
; By Kaid [kaid@excite.fr]



.INCLUDE USGARD.H
.ORG 0
.DB "ImageView",0

POS_MENU     = TEXT_MEM         ;Position dans le menu
NB_FICHIERS  = TEXT_MEM+1       ;Nombre de fichiers trouvs
TAB_FICHIERS = TEXT_MEM+2       ;Tableau d'adresses des fichiers

; * Recherche des fichiers dans la VAT * 

        XOR A                   ;
        LD (NB_FICHIERS),A      ;On met  zro le nombre de fichiers trouvs

        LD IX,TAB_FICHIERS      ;Pour stocker les adresses
        LD HL,VAT_START-10      ;La premire string est Usgard.
                                             
Cherche_Boucle:

        LD A,$0C                ;
        CALL SEARCH_VAT         ;Recherche d'une string
        JR C,Cherche_Fin        ;Si CF, plus de fichiers

        PUSH HL
        EX DE,HL                ;DE Pointe sur la prochaine entre dans la VAT
                                ;HL Pointe sur la variable (donnes)

        LD A,5                  ;On teste si le premier octect de la chaine 
        CPI                     ;est 5.
        JR NZ,Cherche_Prochain  ;Si diffrent, ce n'est pas un fichier d'IV

        XOR A                   ;On teste si le premier octect de la chaine 
        CPI                     ;est 0.
        JR NZ,Cherche_Prochain  ;Si diffrent, ce n'est pas un fichier d'IV

        LD (IX),L               ;Stocke l'adresse du programme
        INC IX                  ;
        LD (IX),H               ;
        INC IX                  ;

        LD HL,NB_FICHIERS       ;
        INC (HL)                ;Incrmente le nombre de fichiers trouvs

Cherche_Prochain:
        POP HL
        JR Cherche_Boucle


Cherche_Fin:

; * Fin de la recherche *

        CALL &IniEcran          ;Initialise l'cran
     
        XOR A
        LD HL,NB_FICHIERS

        CP (HL)                 ;Si (HL) est diffrent de 0, alors il y a des
        JR NZ,ImagesPresentes   ; fichiers pour ImageView

; * Pas de fichiers *

        LD HL,$0603
        LD (CURSOR_ROW),HL
        LD HL,&Str_P_I
        CALL D_ZT_STR           ;Affiche "No files"

        CALL OTH_PAUSE          ;Attend la pression d'ENTER
        RET                     ;Retourne au shell

; * Il y a des images *
ImagesPresentes:

        LD A,7                  ;8 est le nombre maxi d'images gres par IV
        CP (HL)                 
        JR NC,NbOk              ;Si (HL)<=7, pas de problmes

        LD (HL),A               ;On traite seulement 8 images

NbOk:

        XOR A                   ;
        LD (POS_MENU),A         ;Initialise la position dans le menu


; * Menu *
DessineMenu:

        CALL &IniEcran          ;Initialise l'cran
        CALL &AffFichiers       ;Affiche les images
        LD DE,POS_MENU          ;DE pointe sur POS_MENU 

; * Boucle du menu *
BoucleMenu:
        CALL &Inv_Barre         ;Inverse la barre de menu

BoucleKey:
        CALL GET_KEY            ;
        OR A                    ;
        JR Z,BoucleKey          ;Boucle tant qu'une touche n'est pas presse

        CALL &Inv_Barre         ;Inverse la barre de menu
                
        CP K_EXIT               ;Si [EXIT]
        RET Z                   ;Retourne au shell

        CP K_UP                 ;Si [UP]
        JR Z,MenuMonte          ;Monte d'un choix 

        CP K_DOWN               ;Si [DOWN]
        JR Z,MenuDescend        ;Descend d'un choix 

        CP K_ENTER              ;Si pas [ENTER]
        JR NZ,BoucleMenu        ;On attend la prochaine touche        

;* [ENTER] presse => Affichage *

        LD A,(DE)               ;A=Position dans le menu
        LD HL,TAB_FICHIERS      ;HL pointe sur le tableau d'adresses

AjustImg:
        OR A                    ;Si A=0, HL pointe sur la bonne image
        JR Z,AjustImg_Fin

        INC HL \ INC HL         ;Pointe sur la prochaine adresse
        DEC A                   ;Dcrmente notre compteur
        JR AjustImg

AjustImg_Fin:

        PUSH HL                 ;
        CALL CLEARLCD           ;
        POP HL                  ;Efface l'cran

        CALL LD_HL_MHL          ;HL Pointe sur le commentaire de l'image
        XOR A
        CPIR                    ;Il pointe maintenant aprs ce commentaire

        LD DE,VIDEO_MEM 
                                ;DE Pointe sur l'image
        EX DE,HL                ;HL=VIDEO_MEM (Destination)

        CALL &DecodeZCP         ;On dcompresse l'image
        CALL OTH_PAUSE          ;On attend la pression d'ENTER
        JR DessineMenu          ;On retourne au menu

; * Monte d'un choix dans le menu *
MenuMonte:
        LD A,(DE)

        OR A                    ;Si nous sommes sur le premier choix, 
        JR Z,BoucleMenu         ; on ne peux aller plus haut

        DEC A
        JR Maj_Pos_Menu         

; * Descend d'un choix dans le menu *
MenuDescend:
        LD A,(NB_FICHIERS)
        LD B,A
        LD A,(DE)
        
        INC A

        CP B                    ;Si nous sommes aprs le dernier choix,
        JR Z,BoucleMenu         ; dplacement impossible
Maj_Pos_Menu:

        LD (DE),A               ;Mise  jour de la nouvelle position
        JR BoucleMenu           ;Boucle sur le menu
        
        



; * Inverse la barre du menu *
Inv_Barre:
        PUSH AF
        PUSH DE

        LD A,(POS_MENU)         ;
        LD L,A \ LD H,128       ;
        CALL MUL_HL             ;HL=POS_MENU*128

        LD DE,VIDEO_MEM+128     ;On dcale  cause du titre 
        ADD HL,DE               
        LD B,7*16               ;Nombre d'octets  "inverser"

Inv_Barre_Boucle:
        LD A,(HL)               ;
        XOR $FF                 ;
        LD (HL),A               ;On "inverse" un octect
        INC HL
        DJNZ Inv_Barre_Boucle

        POP DE
        POP AF

        RET
        
; * Initialise l'cran *
IniEcran:
        CALL CLEARLCD

        LD HL,$0F
        LD (CURSOR_X),HL
        LD HL,&Str_Tit
        CALL D_ZM_STR
        RET

; * Affiche les fichiers IV *
AffFichiers:
        LD HL,TAB_FICHIERS      ;Pointe sur le tableau d'adresses
        LD DE,$0802             ;Position initiale du curseur
        LD A,(NB_FICHIERS)      ;
        LD B,A                  ;B=Nombre de fichiers

AffFichiers_Boucle:
        PUSH HL

        CALL LD_HL_MHL          ;HL pointe sur le commentaire de l'image
        PUSH DE                 ;On sauve DE (Pos. du curseur)
        LD (CURSOR_X),DE                
        CALL D_ZM_STR           ;On affiche le commentaire
        POP DE

        LD A,D \ ADD A,8 \ LD D,A ;Passe le curseur  la ligne suivante

        POP HL
        INC HL \ INC HL         ;HL pointe sur la prochaine adresse
        DJNZ AffFichiers_Boucle
        RET

Str_Tit .DB "-= ImageView v1.0 by Kaid =-",0
Str_P_I .DB "No files",0

.INCLUDE ZCPDECOD.ASM
.END
